/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2022 Loongson Technology Corporation Limited
 */

#ifndef _RTE_CPUFLAGS_LOONGSON_H_
#define _RTE_CPUFLAGS_LOONGSON_H_

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Enumeration of all CPU features supported
 */
enum rte_cpu_flag_t {
	RTE_CPUFLAG_CPUCFG = 0,
	RTE_CPUFLAG_FPU,
	RTE_CPUFLAG_LSX,
	RTE_CPUFLAG_LASX,
	RTE_CPUFLAG_LBT,
	RTE_CPUFLAG_LVZ,
	RTE_CPUFLAG_CRC32,
	RTE_CPUFLAG_AES,
	RTE_CPUFLAG_SHA1,
	RTE_CPUFLAG_SHA2,
	RTE_CPUFLAG_SHA3,
	/* The last item */
	RTE_CPUFLAG_NUMFLAGS /**< This should always be the last! */
};

#include "generic/rte_cpuflags.h"

#ifdef __cplusplus
}
#endif

#endif /* _RTE_CPUFLAGS_LOONGSON_H_ */
